//
// automatically generated by spin2cpp v3.5.0 on Sat Feb 25 23:15:46 2017
// spin2cpp --ccode --main /Users/altergator/Downloads/Freq_Counter_Demo - Archive  [Date 2017.02.25  Time 20/Freq_Counter_Demo.spin 
//

// :::::::[ FIR Filter ]::::::::::::::::::::::::::::::::::::::::::::::::::::::::
/* {

******************************************
*      FIR Filter Propeller Object       *
*  generated by www.phipi.com/fir2pasm   *
*  from the parameters given in the DAT  *
*          section of this file.         *
* (c) Copyright 2011 Bueno Systems, Inc. *
*    See end of file for terms of use.   *
******************************************

Created: Mon Jan 23 12:36:46 2012 UTC

 */
// =======[ Introduction ]======================================================
/*  This object provides a finite inpulse response (FIR) filter capable of filtering
   a single channel of input at a rate set by the user.
''   
   `Usage:
''     
     1. Call `start with an argument of 0 or the address of a two-long array.
''     
     2. `start stops a prior instance of the same object, if one is running.
''     
     3. Once started, the address provided to `start or the one provided by `start
        upon return will point to a "busy" long and, at the next location, a "data" 
        long.
''        
     From `Spin:
''     
     4. Call `filtera with the input datum as its single argument. It will return
        the next output from the filter.
''        
     From `PASM:
''        
     4. To issue the next datum for filtering, write it to the "data" address, then
        write a non-zero value to the "busy" address. When the "busy" long reverts
        back to zero, the filter output will be available at the "data" address.
 */
// =======[ Constants ]=========================================================   
#include <propeller.h>
#include "fir_filter_7k.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#else
#define INLINE__ static
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

static char dat[] = {
  0xf0, 0xaf, 0xbe, 0xa0, 0x04, 0xae, 0xfe, 0x80, 0x07, 0x15, 0xfe, 0x5c, 0x58, 0xf5, 0xbe, 0xa0, 
  0x01, 0xb0, 0xfe, 0x38, 0x58, 0xf3, 0xbe, 0xa0, 0x01, 0xb0, 0xfe, 0x38, 0x58, 0xf1, 0xbe, 0xa0, 
  0x58, 0xf5, 0xbe, 0x84, 0x01, 0xb0, 0xfe, 0x38, 0x58, 0xbd, 0xbe, 0xa0, 0x58, 0xf3, 0xbe, 0x80, 
  0x58, 0xed, 0xbe, 0xa0, 0x58, 0xeb, 0xbe, 0xa0, 0x58, 0xef, 0xbe, 0xa0, 0x01, 0xb0, 0xfe, 0x38, 
  0x58, 0xe9, 0xbe, 0xa0, 0x58, 0xbb, 0xbe, 0xa0, 0x58, 0xe7, 0xbe, 0xa0, 0x58, 0xbf, 0xbe, 0xa0, 
  0x58, 0xe3, 0xbe, 0xa0, 0x58, 0xf1, 0xbe, 0x84, 0x58, 0xe5, 0xbe, 0xa0, 0x58, 0xf5, 0xbe, 0x80, 
  0x58, 0xdf, 0xbe, 0xa0, 0x01, 0xb0, 0xfe, 0x38, 0x58, 0xbd, 0xbe, 0x84, 0x58, 0xc3, 0xbe, 0xa0, 
  0x58, 0xd5, 0xbe, 0xa0, 0x58, 0xe1, 0xbe, 0xa0, 0x58, 0xc7, 0xbe, 0xa0, 0x58, 0xcb, 0xbe, 0xa0, 
  0x58, 0xd1, 0xbe, 0xa0, 0x58, 0xb5, 0xbe, 0xa0, 0x58, 0xed, 0xbe, 0x80, 0x58, 0xeb, 0xbe, 0x84, 
  0x58, 0xd7, 0xbe, 0xa0, 0x58, 0xdb, 0xbe, 0xa0, 0x01, 0xb0, 0xfe, 0x38, 0x58, 0xcd, 0xbe, 0xa0, 
  0x58, 0xb9, 0xbe, 0xa0, 0x58, 0xc5, 0xbe, 0xa0, 0x58, 0xcf, 0xbe, 0xa0, 0x58, 0xf3, 0xbe, 0x84, 
  0x58, 0xe7, 0xbe, 0x84, 0x58, 0xbf, 0xbe, 0x80, 0x58, 0xb7, 0xbe, 0xa0, 0x58, 0xd9, 0xbe, 0xa0, 
  0x58, 0xf5, 0xbe, 0x84, 0x58, 0xdf, 0xbe, 0x84, 0x58, 0xc1, 0xbe, 0xa0, 0x01, 0xb0, 0xfe, 0x38, 
  0x58, 0xc3, 0xbe, 0x84, 0x58, 0xe9, 0xbe, 0x84, 0x58, 0xcb, 0xbe, 0x84, 0x58, 0xb5, 0xbe, 0x84, 
  0x58, 0xed, 0xbe, 0x84, 0x58, 0xe3, 0xbe, 0x84, 0x58, 0xeb, 0xbe, 0x80, 0x58, 0xd7, 0xbe, 0x84, 
  0x58, 0xdb, 0xbe, 0x80, 0x01, 0xb0, 0xfe, 0x38, 0x58, 0xbd, 0xbe, 0x80, 0x58, 0xc9, 0xbe, 0xa0, 
  0x58, 0xf3, 0xbe, 0x84, 0x58, 0xbb, 0xbe, 0x80, 0x58, 0xd9, 0xbe, 0x80, 0x58, 0xe5, 0xbe, 0x80, 
  0x58, 0xf5, 0xbe, 0x80, 0x58, 0xdf, 0xbe, 0x84, 0x58, 0xc1, 0xbe, 0x80, 0x01, 0xb0, 0xfe, 0x38, 
  0x58, 0xd3, 0xbe, 0xa0, 0x58, 0xcd, 0xbe, 0x80, 0x58, 0xe9, 0xbe, 0x84, 0x58, 0xe1, 0xbe, 0x84, 
  0x58, 0xcb, 0xbe, 0x80, 0x58, 0xd1, 0xbe, 0x84, 0x58, 0xb5, 0xbe, 0x84, 0x58, 0xed, 0xbe, 0x80, 
  0x58, 0xbf, 0xbe, 0x84, 0x58, 0xeb, 0xbe, 0x84, 0x58, 0xb7, 0xbe, 0x80, 0x58, 0xd7, 0xbe, 0x84, 
  0x58, 0xdb, 0xbe, 0x84, 0x01, 0xb0, 0xfe, 0x38, 0x58, 0xb9, 0xbe, 0x84, 0x58, 0xc7, 0xbe, 0x84, 
  0x58, 0xd9, 0xbe, 0x80, 0x58, 0xf1, 0xbe, 0x84, 0x58, 0xdf, 0xbe, 0x84, 0x58, 0xc1, 0xbe, 0x84, 
  0x01, 0xb0, 0xfe, 0x38, 0x58, 0xd3, 0xbe, 0x84, 0x58, 0xcd, 0xbe, 0x80, 0x58, 0xc5, 0xbe, 0x84, 
  0x58, 0xc9, 0xbe, 0x84, 0x58, 0xdd, 0xbe, 0xa0, 0x58, 0xcf, 0xbe, 0x80, 0x58, 0xc3, 0xbe, 0x84, 
  0x58, 0xe9, 0xbe, 0x84, 0x58, 0xd5, 0xbe, 0x84, 0x58, 0xf3, 0xbe, 0x84, 0x58, 0xe1, 0xbe, 0x84, 
  0x58, 0xbb, 0xbe, 0x80, 0x58, 0xcb, 0xbe, 0x80, 0x58, 0xd1, 0xbe, 0x80, 0x58, 0xb5, 0xbe, 0x80, 
  0x58, 0xe7, 0xbe, 0x84, 0x58, 0xed, 0xbe, 0x80, 0x58, 0xe3, 0xbe, 0x84, 0x58, 0xeb, 0xbe, 0x80, 
  0x58, 0xef, 0xbe, 0x84, 0x58, 0xb7, 0xbe, 0x84, 0x58, 0xd7, 0xbe, 0x84, 0x58, 0xe5, 0xbe, 0x84, 
  0x58, 0xf5, 0xbe, 0x84, 0x5a, 0x1d, 0xbe, 0x84, 0x0e, 0xb3, 0xbe, 0xa0, 0x01, 0xb2, 0xfe, 0x38, 
  0x0b, 0x1b, 0xfe, 0x5c, 0x5b, 0x1f, 0xbe, 0x84, 0x0f, 0x1d, 0xbe, 0xa0, 0x5c, 0x21, 0xbe, 0x80, 
  0x10, 0x1f, 0xbe, 0xa0, 0x5d, 0x23, 0xbe, 0x80, 0x11, 0x21, 0xbe, 0xa0, 0x5e, 0x25, 0xbe, 0x80, 
  0x12, 0x23, 0xbe, 0xa0, 0x5f, 0x27, 0xbe, 0x80, 0x13, 0x25, 0xbe, 0xa0, 0x60, 0x29, 0xbe, 0x80, 
  0x14, 0x27, 0xbe, 0xa0, 0x61, 0x2b, 0xbe, 0x84, 0x15, 0x29, 0xbe, 0xa0, 0x62, 0x2d, 0xbe, 0x84, 
  0x16, 0x2b, 0xbe, 0xa0, 0x60, 0x2f, 0xbe, 0x80, 0x17, 0x2d, 0xbe, 0xa0, 0x63, 0x31, 0xbe, 0x80, 
  0x18, 0x2f, 0xbe, 0xa0, 0x64, 0x33, 0xbe, 0x80, 0x19, 0x31, 0xbe, 0xa0, 0x65, 0x35, 0xbe, 0x84, 
  0x1a, 0x33, 0xbe, 0xa0, 0x66, 0x37, 0xbe, 0x84, 0x1b, 0x35, 0xbe, 0xa0, 0x67, 0x39, 0xbe, 0x80, 
  0x1c, 0x37, 0xbe, 0xa0, 0x68, 0x3b, 0xbe, 0x80, 0x1d, 0x39, 0xbe, 0xa0, 0x69, 0x3d, 0xbe, 0x80, 
  0x1e, 0x3b, 0xbe, 0xa0, 0x6a, 0x3f, 0xbe, 0x84, 0x1f, 0x3d, 0xbe, 0xa0, 0x6b, 0x41, 0xbe, 0x84, 
  0x20, 0x3f, 0xbe, 0xa0, 0x6c, 0x43, 0xbe, 0x80, 0x21, 0x41, 0xbe, 0xa0, 0x6d, 0x45, 0xbe, 0x80, 
  0x22, 0x43, 0xbe, 0xa0, 0x6e, 0x47, 0xbe, 0x80, 0x23, 0x45, 0xbe, 0xa0, 0x6f, 0x49, 0xbe, 0x84, 
  0x24, 0x47, 0xbe, 0xa0, 0x70, 0x4b, 0xbe, 0x84, 0x25, 0x49, 0xbe, 0xa0, 0x68, 0x4d, 0xbe, 0x80, 
  0x26, 0x4b, 0xbe, 0xa0, 0x71, 0x4f, 0xbe, 0x80, 0x27, 0x4d, 0xbe, 0xa0, 0x6e, 0x51, 0xbe, 0x80, 
  0x28, 0x4f, 0xbe, 0xa0, 0x72, 0x53, 0xbe, 0x84, 0x29, 0x51, 0xbe, 0xa0, 0x73, 0x55, 0xbe, 0x84, 
  0x2a, 0x53, 0xbe, 0xa0, 0x74, 0x57, 0xbe, 0x80, 0x2b, 0x55, 0xbe, 0xa0, 0x75, 0x59, 0xbe, 0x80, 
  0x2c, 0x57, 0xbe, 0xa0, 0x2d, 0x59, 0xbe, 0xa0, 0x76, 0x5d, 0xbe, 0x84, 0x2e, 0x5b, 0xbe, 0xa0, 
  0x77, 0x5f, 0xbe, 0x84, 0x2f, 0x5d, 0xbe, 0xa0, 0x78, 0x61, 0xbe, 0x80, 0x30, 0x5f, 0xbe, 0xa0, 
  0x79, 0x63, 0xbe, 0x80, 0x31, 0x61, 0xbe, 0xa0, 0x7a, 0x65, 0xbe, 0x80, 0x32, 0x63, 0xbe, 0xa0, 
  0x79, 0x67, 0xbe, 0x80, 0x33, 0x65, 0xbe, 0xa0, 0x78, 0x69, 0xbe, 0x80, 0x34, 0x67, 0xbe, 0xa0, 
  0x77, 0x6b, 0xbe, 0x84, 0x35, 0x69, 0xbe, 0xa0, 0x76, 0x6d, 0xbe, 0x84, 0x36, 0x6b, 0xbe, 0xa0, 
  0x37, 0x6d, 0xbe, 0xa0, 0x75, 0x71, 0xbe, 0x80, 0x38, 0x6f, 0xbe, 0xa0, 0x74, 0x73, 0xbe, 0x80, 
  0x39, 0x71, 0xbe, 0xa0, 0x73, 0x75, 0xbe, 0x84, 0x3a, 0x73, 0xbe, 0xa0, 0x72, 0x77, 0xbe, 0x84, 
  0x3b, 0x75, 0xbe, 0xa0, 0x6e, 0x79, 0xbe, 0x80, 0x3c, 0x77, 0xbe, 0xa0, 0x71, 0x7b, 0xbe, 0x80, 
  0x3d, 0x79, 0xbe, 0xa0, 0x68, 0x7d, 0xbe, 0x80, 0x3e, 0x7b, 0xbe, 0xa0, 0x70, 0x7f, 0xbe, 0x84, 
  0x3f, 0x7d, 0xbe, 0xa0, 0x6f, 0x81, 0xbe, 0x84, 0x40, 0x7f, 0xbe, 0xa0, 0x6e, 0x83, 0xbe, 0x80, 
  0x41, 0x81, 0xbe, 0xa0, 0x6d, 0x85, 0xbe, 0x80, 0x42, 0x83, 0xbe, 0xa0, 0x6c, 0x87, 0xbe, 0x80, 
  0x43, 0x85, 0xbe, 0xa0, 0x6b, 0x89, 0xbe, 0x84, 0x44, 0x87, 0xbe, 0xa0, 0x6a, 0x8b, 0xbe, 0x84, 
  0x45, 0x89, 0xbe, 0xa0, 0x69, 0x8d, 0xbe, 0x80, 0x46, 0x8b, 0xbe, 0xa0, 0x68, 0x8f, 0xbe, 0x80, 
  0x47, 0x8d, 0xbe, 0xa0, 0x67, 0x91, 0xbe, 0x80, 0x48, 0x8f, 0xbe, 0xa0, 0x66, 0x93, 0xbe, 0x84, 
  0x49, 0x91, 0xbe, 0xa0, 0x65, 0x95, 0xbe, 0x84, 0x4a, 0x93, 0xbe, 0xa0, 0x64, 0x97, 0xbe, 0x80, 
  0x4b, 0x95, 0xbe, 0xa0, 0x63, 0x99, 0xbe, 0x80, 0x4c, 0x97, 0xbe, 0xa0, 0x60, 0x9b, 0xbe, 0x80, 
  0x4d, 0x99, 0xbe, 0xa0, 0x62, 0x9d, 0xbe, 0x84, 0x4e, 0x9b, 0xbe, 0xa0, 0x61, 0x9f, 0xbe, 0x84, 
  0x4f, 0x9d, 0xbe, 0xa0, 0x60, 0xa1, 0xbe, 0x80, 0x50, 0x9f, 0xbe, 0xa0, 0x5f, 0xa3, 0xbe, 0x80, 
  0x51, 0xa1, 0xbe, 0xa0, 0x5e, 0xa5, 0xbe, 0x80, 0x52, 0xa3, 0xbe, 0xa0, 0x5d, 0xa7, 0xbe, 0x80, 
  0x53, 0xa5, 0xbe, 0xa0, 0x5c, 0xa9, 0xbe, 0x80, 0x54, 0xa7, 0xbe, 0xa0, 0x5b, 0xab, 0xbe, 0x84, 
  0x55, 0xa9, 0xbe, 0xa0, 0x5a, 0xab, 0xbe, 0xa4, 0x02, 0x00, 0x7c, 0x5c, 0xf0, 0xb1, 0xbe, 0x0a, 
  0x07, 0x01, 0x68, 0x5c, 0x57, 0xb1, 0xbe, 0x08, 0x00, 0x00, 0x7c, 0x5c, 0x57, 0xb3, 0x3e, 0x08, 
  0xf0, 0xad, 0x3e, 0x08, 0x00, 0x00, 0x7c, 0x5c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
};
// =======[ Public Spin Methods ]===============================================
int32_t fir_filter_7k_start(fir_filter_7k *self, int32_t *busy_addr)
{
  /*  Start the FIR filter in a new cog.
    ''
    '' `Parameters:
    ''
    ''     `busy_addr: Either 0 or the address of a two-long communication array.
    ''
    '' `Return: The address provided by `busy_addr or the address of the internal
    ''      array if 'busy_addr == 0 if a cog was started; or False (0) if no cog
    ''      was available.
    ''
    '' `Example: fir.start(0)
    ''
    ''     Start the FIR filter object using its internal communication array.
    
   */
  fir_filter_7k_stop(self);
  if (busy_addr) {
    self->busyaddr = (uint16_t)busy_addr;
  } else {
    self->busyaddr = (uint16_t)(&self->busy);
  }
  self->cogno = cognew((int32_t)(((int32_t *)&dat[0])), self->busyaddr);
  return (self->busyaddr & -((++self->cogno) != 0));
}

void fir_filter_7k_stop(fir_filter_7k *self)
{
  int32_t 	_tmp__0001;
  /*  Stop the FIR filter cog if one was started.
    ''
    '' `Example: fir.stop
    ''
    ''     Stop the FIR filter cog.
    
   */
  if (self->cogno) {
    cogstop(( ( (_tmp__0001 = self->cogno), (self->cogno = 0) ), _tmp__0001 ) - 1);
  }
}

int32_t fir_filter_7k_filtera(fir_filter_7k *self, int32_t yy)
{
  ((int32_t *)self->busyaddr)[1] = yy;
  ((int32_t *)self->busyaddr)[0] = 1;
  while (((int32_t *)self->busyaddr)[0]) {
    Yield__();
  }
  return ((int32_t *)self->busyaddr)[1];
}

// =======[ License ]==========================================================
/* {
***************************************************************************************
*                                                                                     *
* Permission is hereby granted, free of charge, to any person obtaining a copy of     *
* this software and associated documentation files (the "Software"), to deal in       *
* the Software without restriction, including without limitation the rights to use,   *
* copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the     *
* Software, and to permit persons to whom the Software is furnished to do so,         *
* subject to the following conditions:                                                *
*                                                                                     *
* The above copyright notice and this permission notice shall be included in all      *
* copies or substantial portions of the Software.                                     *
*                                                                                     *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, *
* INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A       *
* PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT  *
* HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION   *
* OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                              *
*                                                                                     *
***************************************************************************************
 */
